// Slider.h: interface for the CSlider class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __SLIDER_HEADER__
#define __SLIDER_HEADER__

#pragma once

#define WM_UPDATE	WM_USER+98
#define WM_CHANGE	WM_USER+99

#define TYPE_HORIZONTAL	1
#define TYPE_VERTICAL	2

#define MODE_NONE			0
#define MODE_VOLUME			1
#define MODE_BALANCE		2
#define MODE_WINAMP			3
#define MODE_WINAMPVOLUME	4

#define TIMER_UPDATE	1

#define CONFIG_TOKENS_NUM	9

class CSlider
{
public:
	// type and mode constants are listed above
	int m_nType, m_nMode;
	bool m_bInverted, m_bVisible;
	bool m_bInitialized;
	// hSlider is a slider window, hHandle - handle :)
	HWND m_hSlider, m_hHandle;
	// dcmain for hSlider, dchand for handle
	HDC m_dcMain, m_dcHand;
	// handle offset in according to the settings
	int m_nHandleOffset;
	int m_nX, m_nY;
	int m_nWidth, m_nHeight;
	int m_nHX, m_nHY;
	int m_nHWidth, m_nHHeight;
	int m_nChannel;
	int m_nGroup;

	CSlider();
	virtual ~CSlider();

	bool LoadParameters(char token[CONFIG_TOKENS_NUM][MAX_LINE_LENGTH], HBITMAP &hbmBackground, HBITMAP &hbmHandle);
	bool LoadHandlePosition(bool bExist);

	bool CreateUI(
			const char *szCaption,
			HBITMAP background,
			HBITMAP handle,
			const char *flags);

	// message handlers
	void onUpdate();
	void onLButtonDown(int x, int y);
	void onPosChanging(WINDOWPOS *pPos);

	// bang handlers
	void Show();
	void Hide();
	void ToggleVisibility();
	void Hook(HWND hwndParent);
};

#endif
