#ifndef __VOLUME_CONTROL_HEADER__
#define __VOLUME_CONTROL_HEADER__

#define VOLUME_STEP		10
#define BALANCE_STEP	10

class CVolumeControl
{
	HMIXER m_hMixer;	// Mixer handle used in mixer API calls.

	typedef vector<MIXERCONTROL> MIXERCONTROLvector;
	typedef vector<MIXERCONTROL>::iterator MIXERCONTROLiterator;

	MIXERCONTROLvector m_vLines;
	MIXERCONTROLvector m_vMutes;

	void GetLineControls(MIXERLINE &mxl);
public:
	CVolumeControl(HWND hWnd);
	~CVolumeControl();
	void GetVolume(int channel, int &left, int &right);
	void SetVolume(int channel, int left, int right);
	void ChangeBalance(int channel, int value);
	void ChangeVolume(int channel, int value);
	void VolumeUp(int channel);
	void VolumeDown(int channel);
	void SetMute(int channel, bool bMute);
	bool GetMute(int channel);
	void BalanceLeft(int channel);
	void BalanceRight(int channel);

	int m_nCode;
};

#endif
