#include "stdafx.h"
#include "utils.h"
#include "main.h"

///////////////////////////////////////////////////////////////////
//
// Message box + logging
//
void utils::ErrorBox(const char *szMessage)
{
	MessageBox(NULL, szMessage, "UniMedia Slider :: Error", MB_OK);
	LSLog(LOG_ERROR, g_szAppName, szMessage);
}


void utils::ErrorBoxPrint(const char *szFormat, ...)
{
	// Format the message
	char szMessage[MAX_LINE_LENGTH];
	va_list argList;

	va_start(argList, szFormat);
	StringCchVPrintf(szMessage, MAX_LINE_LENGTH, szFormat, argList);
	va_end(argList);

	ErrorBox(szMessage);
}


//////////////////////////////////////////////////////////////////////////////////////
//
// Retrieve a handle of the desktop window
//
HWND utils::GetLitestepDesktop()
{
	HWND hWnd = FindWindow("DesktopBackgroundClass", 0);

	if(hWnd != 0)
		return hWnd;

	return GetDesktopWindow();
}


int utils::ErrorBoxE( HWND hWnd, LPCSTR pszText, DWORD dwErrorCode, LPCSTR pszTitle, UINT nFlags )
{
	char szMessage[MAX_PATH];
	int nLen;

	StringCchCopy(szMessage, MAX_PATH, pszText);
	StringCchCat(szMessage, MAX_PATH, " ");
	nLen = lstrlen(szMessage);

	FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, 0, dwErrorCode,
	              MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), szMessage + nLen,
	              MAX_PATH - nLen, NULL);

	return MessageBox( hWnd, szMessage, pszTitle, nFlags | MB_TOPMOST);
}
